Attribute VB_Name = "WinAMPFE"
'----------------------------------------------------------------------
' Deeth WinAMP Front End Visual Basic Module
' Release 2
' By Murphy McCauley (MurphyMc@Concentric.NET) 08/16/99
'----------------------------------------------------------------------
' This has all the constants from Nullsoft's frontend.h converted to
' VB form.  Also, I've declared some API functions, constants, and
' structures (Types) that are useful when controlling WinAMP, and
' included GetWindowTitle() which gets the title for a given hWnd.
'----------------------------------------------------------------------
' http://www.fullspectrum.com/deeth/
'----------------------------------------------------------------------

Option Explicit

Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Declare Function SendMessageM Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Declare Function IsWindow Lib "user32" (ByVal hwnd As Long) As Long

Public Const WM_USER = &H400
Public Const WM_COMMAND = &H111
Public Const WM_COPYDATA = &H4A   ' enqueue file to playlist
Public Const WM_WA_IPC = 1024

Public Type COPYDATASTRUCT
        dwData As Long
        cbData As Long
        lpData As Long
End Type

Public Const IPC_GETVERSION = 0
Public Const IPC_DELETE = 101
Public Const IPC_STARTPLAY = 102
Public Const IPC_ISPLAYING = 104
Public Const IPC_GETOUTPUTTIME = 105
Public Const IPC_JUMPTOTIME = 106
Public Const IPC_WRITEPLAYLIST = 120
Public Const IPC_SETPLAYLISTPOS = 121
Public Const IPC_SETVOLUME = 122
Public Const IPC_SETPANNING = 123
Public Const IPC_GETLISTLENGTH = 124
Public Const IPC_SETSKIN = 200
Public Const IPC_GETSKIN = 201
Public Const IPC_EXECPLUG = 202
Public Const IPC_GETPLAYLISTFILE = 211
Public Const IPC_GETPLAYLISTTITLE = 212
Public Const IPC_GETLISTPOS = 125
Public Const IPC_GETINFO = 126
Public Const IPC_GETEQDATA = 127
Public Const IPC_SETEQDATA = 128
Public Const IPC_PLAYFILE = 100
Public Const IPC_CHDIR = 103
Public Const WINAMP_OPTIONS_EQ = 40036              ' toggles the EQ window
Public Const WINAMP_OPTIONS_PLEDIT = 40040          ' toggles the playlist window
Public Const WINAMP_VOLUMEUP = 40058                ' turns the volume up a little
Public Const WINAMP_VOLUMEDOWN = 40059              ' turns the volume down a little
Public Const WINAMP_FFWD5S = 40060                  ' fast forwards 5 seconds
Public Const WINAMP_REW5S = 40061                   ' rewinds 5 seconds
Public Const WINAMP_BUTTON1 = 40044
Public Const WINAMP_BUTTON2 = 40045
Public Const WINAMP_BUTTON3 = 40046
Public Const WINAMP_BUTTON4 = 40047
Public Const WINAMP_BUTTON5 = 40048
Public Const WINAMP_BUTTON1_SHIFT = 40144
Public Const WINAMP_BUTTON2_SHIFT = 40145
Public Const WINAMP_BUTTON3_SHIFT = 40146
Public Const WINAMP_BUTTON4_SHIFT = 40147
Public Const WINAMP_BUTTON5_SHIFT = 40148
Public Const WINAMP_BUTTON1_CTRL = 40154
Public Const WINAMP_BUTTON2_CTRL = 40155
Public Const WINAMP_BUTTON3_CTRL = 40156
Public Const WINAMP_BUTTON4_CTRL = 40157
Public Const WINAMP_BUTTON5_CTRL = 40158
Public Const WINAMP_FILE_PLAY = 40029               ' pops up the load file(s) box
Public Const WINAMP_OPTIONS_PREFS = 40012           ' pops up the preferences
Public Const WINAMP_OPTIONS_AOT = 40019             ' toggles always on top
Public Const WINAMP_HELP_ABOUT = 40041              ' pops up the about box :)

Function GetWindowTitle(TheHWnd As Long) As String
    Dim Title As String
    If IsWindow(TheHWnd) Then
        Title = Space$(GetWindowTextLength(TheHWnd) + 1)
        Call GetWindowText(TheHWnd, Title, Len(Title) + 20)
        Title = Left$(Title, Len(Title) - 1)
    End If
    GetWindowTitle = Title
End Function
