Attribute VB_Name = "mCommon"
'Music Collector
'
'(c) 1999, 2000 by Joe Hart
'
'You do NOT have rights to redistribute this code, in whole or in part without
'my permission.  You also may not recompile the code and release
'it as another program without my permission.  If you would like to modify this code
'and distribute it in either as source code or as a compiled program please contact
'me at bghost@ti.cz before doing so.
'
'No warrantees either expressed or implied are granted with this software.
'Any damage arrising from use of this software is your own risk.
'
'This module contains commonly used routines for Windows and routines that are
'used by more that one form.
'
Option Explicit
Public Const sDash = " - "
Public Const sQuote2 = """"
Public Const sEmpty = ""
Public Const sBSlash = "\"
Public Const cMaxPath = 260
Public Const REG_DWORD = 4
Public Const REG_BINARY = 3
Public Const FO_COPY = 2
Public Const FOF_SIMPLEPROGRESS = 256
Public Const FO_DELETE = 3
Public Const FOF_ALLOWUNDO = 64
Public Const GENERIC_WRITE = 1073741824
Public Const OPEN_EXISTING = 3
Public Const FILE_FLAG_BACKUP_SEMANTICS = 33554432
Public Const INI_FILE = "E-MusiC.ini"


Private Declare Function CreateFile Lib "Win32.dll" (lpFileName As String, dwDesiredAccess As Long, dwShareMode As Long, lpSecurityAttributes As Long, dwCreationDisposition As Long, dwFlagsAndAttributes As Long, hTemplateFile As Long) As Long
Private Declare Function SetFilePointer Lib "Win32.dll" (hFile As Long, lDistanceToMove As Long, lpDistanceToMoveHigh As Long, dwMoveMethod As Long) As Long
Private Declare Function SetEndOfFile Lib "Win32.dll" (hFile As Long) As Long
Private Declare Function CloseHandle Lib "Win32.dll" (hObject As Long) As Long
Private Declare Function GetFileAttributes Lib "Win32.dll" (lpFileName As String) As Long
Private Declare Function GetFileAttributesLib Lib "Win32.dll" (lpFileName As String) As Long
Private Declare Function FileTimeToLocalFileTime Lib "Win32.dll" (lpFileTime As Any, lpLocalFileTime As Any) As Long
Private Declare Function QueryPerformanceFrequency Lib "Win32.dll" (lpFrequency As Any) As Long
Private Declare Function QueryPerformanceCounter Lib "Win32.dll" (lpPerformanceCount As Any) As Long



Private secFreq As Currency
'structures (User Defined Types) not in the type library
Private Type udtBrowseInfo
    hWndOwner As Long
    pidlRoot As Long
    sDisplayName As String
    sTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    Image As Long
End Type

'not in the type library
Private Declare Function SHBrowseForFolder Lib "Shell32.dll" (bBrowse As udtBrowseInfo) As Long



Public Function BrowseForDirectory(hwnd As Long, Title As String) As String
   'calls the browse for folder dialog
   Dim BrowseInfo As udtBrowseInfo
   Dim Item As Long
   Dim sDir As String
      
   BrowseInfo.hWndOwner = hwnd
   BrowseInfo.pidlRoot = 0
   BrowseInfo.sDisplayName = Space$(cMaxPath)
   BrowseInfo.sTitle = Title
   BrowseInfo.ulFlags = 1 ' Return directory name.
   BrowseInfo.lpfn = 0
   BrowseInfo.lParam = 0
   BrowseInfo.Image = 0
   
   Item = SHBrowseForFolder(BrowseInfo)
   If Item Then
       sDir = Space$(260)
       If SHGetPathFromIDList(Item, sDir) Then
           BrowseForDirectory = Left(sDir, InStr(sDir, vbNullChar) - 1)
       Else
           BrowseForDirectory = sEmpty
       End If
   End If
End Function
Public Function Delay(ByVal Seconds As Single) As Boolean
   'delay for specified number of seconds, can be fractional.
   Dim r As Single
   r = Timer
   Do Until Timer - r > Seconds
      DoEvents
   Loop
End Function

Function ReadRegistry(ByVal Group As Long, ByVal Section As String, ByVal Key As String) As String
   Dim Result As Long
   Dim KeyValue As Long
   Dim DataTypeValue As Long
   Dim ValueLength As Long
   Dim sValue As String
   Dim rData As Double
   Dim sTemp As String
   Dim sHexOut As String
   
   On Error Resume Next
   'open the registry section
   Result = RegOpenKey(Group, Section, KeyValue)
   'prepare variables
   sValue = Space$(2048)
   ValueLength = 2048
   'get key value
   Result = RegQueryValueEx(KeyValue, Key, ZERO, DataTypeValue, sValue, ValueLength)
   'if key is good...
   If (Result = 0) And (Err.Number = 0) Then
      Select Case DataTypeValue
      Case REG_DWORD
         'Return a number in a string
         rData = Asc(Mid$(sValue, 1, 1)) + &H100& * Asc(Mid$(sValue, 2, 1)) + &H10000 * Asc(Mid$(sValue, 3, 1)) + &H1000000 * CDbl(Asc(Mid$(sValue, 4, 1)))
         ReadRegistry = Format$(rData, "000")
      Case REG_BINARY
          ' Return a binary field as a hex string (2 chars per byte)
          sHexOut = sEmpty
          For i = 1 To ValueLength
             sTemp = Hex(Asc(Mid$(sValue, i, 1)))
             If Len(sTemp) = 1 Then sTemp = "0" & sTemp
             sHexOut = sHexOut + sTemp
          Next
          ReadRegistry = sHexOut
      Case Else
         'Return a string
         ReadRegistry = Left$(sValue, ValueLength - 1)
      End Select
   Else
      'was not found
      ReadRegistry = NOT_FOUND
   End If
   'close the registry
   Result = RegCloseKey(KeyValue)
End Function

Sub MoveSong(ByVal Filename As String, ByVal Artist As String)
   'move a song, renaming it.
   
   Dim sNewLocation As String
   Dim sName As String
   
   If gsPlayingFileName = Filename Then StopPlayer
   'separate filename from path
   sName = Right$(Filename, Len(Filename) - InStrRev(Filename, sBSlash))
   'create the new filename
   sNewLocation = sMoveDir & Artist & sDash & sName
   'and rename it (also moves it)
   Name Filename As sNewLocation
   'change filename in database
   f = Data.SetNewFileName(Filename, sNewLocation)
   'if successful
   If f Then
      'show new path in grid
      With FMain.Grid1
         .TextMatrix(.Row, colFileName) = sNewLocation
         .TextMatrix(.Row, colVolume) = VolLabel
      End With
   End If
End Sub

Public Sub CopySong(Filename As String, Artist As String)
   'copy song, rename the copy.
   
   Dim SHop As SHFILEOPSTRUCT
   Dim sTo As String
   Dim sName As String
   
   'separate filename from path
   sName = Right$(Filename, Len(Filename) - InStrRev(Filename, sBSlash))
   'create the new filename
   sTo = sCopyDir & Artist & sDash & sName & vbNullChar & vbNullChar
   'append the nulls to the filename
   Filename = Filename & vbNullChar & vbNullChar
   'define the structure
   With SHop
      .wFunc = FO_COPY
      .pFrom = Filename
      .pTo = sTo
      .fFlags = FOF_SIMPLEPROGRESS
   End With
   'and do it
   L = SHFileOperation(SHop)
End Sub

Sub SendToRecycleBin(ByVal FileNames As Variant)
   'send a file or files to the recycle bin.
   
   Dim SHop As SHFILEOPSTRUCT
   Dim From As String
   
   'can be more than one filename... must be either a string or an array of strings
   If IsArray(FileNames) Then
      For i = 0 To UBound(FileNames)
         'build one long string, appending null in between filenames.
         From = From & FileNames(i) & vbNullChar
      Next i
   Else
      From = FileNames & vbNullChar
   End If
   'two nulls signify the end
   From = From & vbNullChar
   'set up operation
   With SHop
      .wFunc = FO_DELETE
      .pFrom = From
      .fFlags = FOF_ALLOWUNDO
   End With
   
   'do it.
   L = SHFileOperation(SHop)
End Sub

Function SetFileLength(ByVal Filename As String, ByVal NewLength As Long) As Boolean
'Will cut the length of a file to the length specified.
   
   Dim hFile As Long
   
   'if file is smaller than or equal to requsted length, exit.
   If FileLen(Filename) <= NewLength Then Exit Function
   'open the file
   hFile = CreateFile(Filename, GENERIC_WRITE, ZERO, ByVal ZERO, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, 0)
   'if file not open exit
   If hFile = -1 Then Exit Function
   'seek to position
   L = SetFilePointer(hFile, NewLength, ZERO, ZERO)
   'and mark here as end of file
   SetFileLength = SetEndOfFile(hFile)
   'close the file
   L = CloseHandle(hFile)
End Function

Function Exists(ByVal Filename As String) As Boolean
'Determine if a file exists.  VB should have this function
   
   Dim L As Long
   
   L = GetFileAttributes(Filename)
   Exists = (L <> -1)
End Function

Function FileTimeToDouble(ftUTC As FILETIME) As Double
'convert filetime to a double
   
   Dim ft As FILETIME
   Dim st As SYSTEMTIME
   
   ' Convert to local filetime.
   Call FileTimeToLocalFileTime(ftUTC, ft)
   
   ' Convert to system time structure.
   Call FileTimeToSystemTime(ft, st)
   
   ' Convert to VB-style date (double).
   FileTimeToDouble = DateSerial(st.wYear, st.wMonth, st.wDay) + TimeSerial(st.wHour, st.wMinute, st.wSecond)
End Function



Public Function NullTrim(ByRef s) As String
'convert a null terminated string to standard vb string, deleting any leading or trailing spaces
     i = InStr(s, vbNullChar)
     If i > 0 Then s = Left$(s, i - 1)
     s = Trim$(s)
     NullTrim = s
End Function

Sub ProfileStart(secStart As Currency)
'accurate timer start
   If secFreq = 0 Then QueryPerformanceFrequency secFreq
   QueryPerformanceCounter secStart
End Sub

Sub ProfileStop(secStart As Currency, secTiming As Currency)
'accurate timer stop
    QueryPerformanceCounter secTiming
    If secFreq = 0 Then
        secTiming = 0 ' timer was not started.
    Else
        secTiming = (secTiming - secStart) / secFreq
    End If
End Sub


Function FormatTime(ByVal Secs As Long) As String
   Dim Hrs As Long
   Dim Min As Long
   Dim Sec As Long
   Dim s As String
   Hrs = Secs \ 3600
   Min = Secs \ 60 Mod 60
   Sec = Secs Mod 60
   If Hrs > 0 Then s = Format$(Hrs, "00:")
   FormatTime = s & Format$(Min, "00:") & Format$(Sec, "00")
End Function




Function GetFileName(FullPath As String)


GetFileName = Left(Right(FullPath, Len(FullPath) - InStrRev(FullPath, "\")), Len(Right(FullPath, Len(FullPath) - InStrRev(FullPath, "\"))))

End Function









